<script setup>
import { computed, ref, shallowRef, triggerRef } from 'vue';
import { locked, elmId } from '../itemsBase';
import { spellCost } from 'modules/craft';
import { alphasort } from '../../util/util';
import { useRollOver } from '../../store/popups';

const props = defineProps(['state']);

const { itemOver } = useRollOver();
const userSpells = computed(()=>props.state.userSpells);

/**
 * List of spells in current crafting.
 */
const list = shallowRef([]);

/**
 * Craft info object.
 */
const craft = shallowRef({
	name: 'Crafted Spell',
	level: 0,
	buy: null
});



/**
 * Remove user spell from UserSpells
 */
function removeSpell(s) {
	userSpells.value.remove(s);
}

function canAdd(s) {
	return s.level + craft.value.level <= maxLevels.value;
}

/**
 * @function create - create the new spell combination.
 */
function create() {

	const curList = list.value;
	if (!curList || curList.length === 0) return;

	props.state.payCost(craft.value.buy);

	userSpells.value.create(curList, props.state, craft.value.name);
	list.value = [];

	craft.value.level = 0;
	craft.value.buy = null;

}

/**
 * Add spell to the current crafting group.
 * Crafted level = list total levels + list.length - 1
 */
const addSpell = (s) => {

	list.value.push(s);
	craft.value.level += s.level;
	craft.value.buy = spellCost(list.value);

	triggerRef(list);
	triggerRef(craft);
}

/**
 * Remove spell from building list.
 */
function removeAt(i) {

	const s = list.value[i];

	if (s) {
		craft.value.level -= s.level;
	}

	list.value.splice(i, 1);
	craft.value.buy = spellCost(list.value);

	triggerRef(list);
	triggerRef(craft);

}



/**
 * Determine if the group being created can be crafted.
 * cost+length + user slots available.
 * @returns {boolean}
 */
const canCraft = computed(() => {
	return !userSpells.value.full() && list.value.length > 0
		&& props.state.canPay(craft.value.buy);

});

/**
 * @property {Spell[]} spells - all spells in game, except bloodshot.
 */
const spells = computed(() => {
	return props.state.filterItems(v => v.type === 'spell' && !locked(v) && v.owned && !v.hasTag('t_nospellcraft')).sort(alphasort);
});

/**
 * Spellcraft power.
 */
const scraft = computed(() => {
	return props.state.getData('scraft');
});

const maxLevels = computed(() => {
	return Math.floor(scraft.value.valueOf());
});

</script>

<template>

<div class="spellcraft">

<div class="userspells">

	<div>
		Custom Spells: {{ Math.floor(userSpells.used) + ' / ' + Math.floor(userSpells.max.value) }}
	</div>
	<div class="spells">
	<div class="custom" v-for="c in userSpells.items" :key="c.id" @mouseenter.capture.stop="itemOver($event, c)">
		<span class="text-entry">
			<input class="fld-name" type="text" v-model="c.name">
		</span>
		<button class="stop" @click="removeSpell(c)">X</button>
	</div>
	</div>

</div>

<div class="bottom">
<div class="crafting">

	<div class="options">
		<span class="warn-text" v-if="craft.level >= maxLevels">You are at your power limit.</span>

		<div class="text-entry"><label :for="elmId('spName')">Spell</label>
		<input class="fld-name" :id="elmId('spName')" type="text" v-model="craft.name">
		</div>

		<!--chrome wrap-->
		<span @mouseenter.capture.stop="itemOver($event, craft)">
		<span>Power: {{ craft.level + ' / ' + Math.floor(maxLevels) }}</span>
		<button @click="create" :disabled="!canCraft">Craft</button>
		</span>

	</div>

	<div v-for="(s, ind) in list" class="separate" :key="ind" @mouseenter.capture.stop="itemOver($event, s)">
		<span>{{ s.name.toTitleCase() }}</span><button class="remove" @click="removeAt(ind)">X</button>
	</div>

</div>
<div class="allspells">

	<div class="separate" v-for="(s) in spells" :key="s.id"  @mouseenter.capture.stop="itemOver($event, s)">
		<span>{{ s.name.toTitleCase() }}</span><button class="add" @click="addSpell(s)" :disabled="!canAdd(s)">+</button>
	</div>

</div>
</div>

</div>

</template>

<style scoped>
div.spellcraft {
	display: flex;
	flex-direction: column;
}

div.spellcraft .userspells {
	display: flex;
	flex-direction: column;
	padding: var(--md-gap);
	border-bottom: 1pt solid var(--separator-color);
}

div.userspells .spells {
	display: flex;
	flex-flow: row wrap;
}

div.spells .custom {
	margin-right: 1.2rem;
}

.crafting .options {
	padding-bottom: var(--tiny-gap);
}

div.spellcraft .bottom {
	display: flex;
	flex-direction: row;
	justify-content: space-between;
	padding-top: var(--md-gap);
	padding-left: var(--md-gap);
}

div.spellcraft .crafting,
div.spellcraft .allspells {
	display: flex;
	flex-direction: column;
}
</style>